/*
The Propogator - creates multiple copies of files to the same directory 
Author: Target
Date: April 09

Desc:
provides the functionality to duplicate files X number of times within the same folder.
Use keyboard shortcut (WIN+V) to duplicate all copied files or drag and drop onto the drop target. 
Copied files will be named in the format ORIGINAL NAME_YYYY-MM-DD_COPY NUMBER, ie test.txt would become TEST_2009-04-18_1.TXT

NOTE - to the best of my knowledge this script ONLY works with Windows Explorer 

HotKeys:
WIN+V - paste copied files
ALT+WIN+V - paste copies to a new directory (user prompted for the target dir)
F12 - opens an input box allowing the user to set the number of copies
ALT+CTRL+X - quit
*/

fileinstall, propagator.gif, propagator.gif

#persistent
#singleinstance
menu, tray, nostandard
menu, tray, noicon
copies:=1
target:="::{20d04fe0-3aea-1069-a2d8-08002b30309d}"

Win_List = ExploreWClass`,CabinetWClass

loop
{
	wingettitle, Win_Title, A
	wingetclass, Win_Class, %Win_Title%
	if Win_Class contains %Win_List%	
	{
		ifwinnotexist, ThePropagator
			gosub, Drop_Target
	}
	else
		gui, 1:destroy
	sleep, 500
}
return

Drop_Target:
gui, add, text, w10 10 y12, .
gui +toolwindow 
gui, 2:+owner1
gui, 2:add, picture,, propagator.gif
gui, 2:show, x150 y100
winset, region, 11-28 w173 h103 r20-20, ThePropagator
winset, transparent, 75, ThePropagator
gui 2:+alwaysontop +owndialogs 
winactivate, %Win_Title%
return

guidropfiles:
formattime, TDY,, yyyy-MM-dd
loop, parse,a_guievent,`n
{
	splitpath, a_loopfield,tmp1,tmpDIR, tmpXTN,tmpNAME,tmp2
	loop, %Copies%
	{
		outfile:=tmpDIR . "\" . tmpNAME . "_" . TDY . "_" . a_index . "." . tmpXTN
		filecopy, %a_loopfield%, %outfile%, 1
	}	
}
send {F5}
return

#F10::reload

!^X::exitapp

$F12::
if Win_Class not in %Win_List%
	return
else
{
	inputbox, TMPcopies, Iterations, enter the required number of copies,,130,130,,,,,%copies%
	if errorlevel
		return
	copies:=TMPCopies
}
return

$#V::
if Win_Class not in %Win_List%
	sendinput #v	
else
{
	formattime, TDY,, yyyy-MM-dd
	loop, parse,clipboard,`n,`r
	{
		splitpath, a_loopfield,tmp1,tmpDIR, tmpXTN,tmpNAME,tmp2
		loop, %Copies%
		{
			outfile:=tmpDIR . "\" . tmpNAME . "_" . TDY . "_" . a_index . "." . tmpXTN
			filecopy, %a_loopfield%, %outfile%, 1
		}	
	}
}
send {F5}
return

$!#V::
PasteMeThere:
if Win_Class not in %Win_List%
	sendinput !#v	
else
{
	fileselectfolder, Target,*%target%,3, Select the folder to COPY to
	formattime, TDY,, yyyy-MM-dd
	loop, parse,clipboard,`n,`r
	{
		splitpath, a_loopfield,tmp1,tmpDIR, tmpXTN,tmpNAME,tmp2
		loop, %Copies%
		{
			outfile:= target . "\" . tmpNAME . "_" . TDY . "_" . a_index . "." . tmpXTN
			filecopy, %a_loopfield%, %outfile%, 1
		}	
	}
}
send {F5}
return


